// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

library passive_data.test.complementary_test;

import 'package:test/test.dart';
import 'package:passive_data/passive_data.dart';

Map<List<String>, List<bool>> data = {
  ['int', 'int']: [true],
  ['Map<int, bool>', 'Map<int, bool>']: [true],
  ['DateTime', 'Map<String, dynamic>']: [true],
  ['DateTime', 'String']: [true],
  ['List<Set<Object>>', 'List<List<Map<String, dynamic>>>']: [true],

  // Not complementary.
  ['int', 'num']: [false],
  ['Map<int, bool>', 'Map<int, int>']: [false],
  ['DateTime', 'Object']: [false, true],
  ['DateTime', 'DateTime']: [false, true],
  ['List<Set<Object>>', 'Set<List<Map>>']: [false, true]
};

void main() {
  test('Check isComplementaryPdsType', () {
    data.forEach((List<String> types, List<bool> expected) {
      if (expected.length > 1) {
        // Throws ArgumentError.value
        expect(() => isComplementaryPdsType(types[0], types[1]),
            throwsArgumentError);
      } else {
        expect(isComplementaryPdsType(types[0], types[1]), equals(expected[0]));
      }
    });
  });
}
