// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

library passive_data.test.is_pds_type_test;

import 'package:test/test.dart';
import 'package:passive_data/passive_data.dart';

const Map<String, bool> data = const {
  'dynamic': true,
  'num': true,
  'int': true,
  'double': true,
  'bool': true,
  'String': true,
  'List': true,
  'List<int>': true,
  'Map<int, bool>': true,

  // No PDS.
  'Set': false,
  'Set<num>': false,
  'List<Set<Object>>': false,
  'Map<num, String>': false,
  'DateTime': false
};

void main() {
  test('Check isPdsType', () {
    data.forEach((String type, bool expected) {
      expect(isPdsType(type), equals(expected));
    });
  });
}
