// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

library passive_data.test.parse_test;

import 'package:test/test.dart';
import 'package:passive_data/passive_data.dart';

class NonPassive {
  DateTime nullValue;
  num integer = 0;
  bool boolean = true;
  String string = 'hello';
  List<String> list = ['Hello', 'World', '!'];
  Set<int> intSet = new Set<int>.from([0, 1, 2, 3]);
  Map<int, int> map = {1: 2, 2: 1};
  dynamic toPds() {
    return {
      'nullValue': nullValue,
      'integer': integer,
      'boolean': boolean,
      'string': string,
      'list': list,
      'intSet': intSet,
      'map': map
    };
  }
}

class NonPassiveNoToPds {
  int value = 0;
}

void main() {
  test('Test basic usage of toPds()', () {
    var noPds = new NonPassive();
    var noNoPds = new NonPassiveNoToPds();
    var pds = deepConvertToPds(noPds);
    expect(pds is Map<String, dynamic>, equals(true));
    expect(() => deepConvertToPds(noPds, false), throwsArgumentError);
    expect(deepConvertToPds(noPds), isNotNull);
    expect(() => deepConvertToPds(noNoPds), throwsArgumentError);
  });
}
